-- boards.lua v1.1 -- Revised by Tallow
--
-- Run a set of sawmills to generate boards.
--

dofile("common.inc");

askText = singleLine([[
  Board Maker v1.2 (Revised by Tallow, revised by tripps) --
  Automatically planes boards from any number of Wood Plane or
  Carpentry Shop windows. Make sure the VT window is in the TOP-RIGHT
  corner of the screen.
]]);

wmText = "Tap control on Wood Planes or Carpentry Benches to open and pin.";

--Amount of time to pause after clicking the plane woods button (ms)
pause_time = 1000; 

--Colour short cuts
Opaque = 0xFFFFFFFF
Transparent = 0x00000000
Black = 0x000000FF
White = 0xFFFFFFFF
Red = 0xFF0000FF
Green = 0x00FF00FF
Blue = 0x0000FFFF
Cyan = 0x00FFFFFF
Magenta = 0xFF00FFFF
Yellow = 0xFFFF00FF
PaleYellow = 0xFFFFAAFF
DarkYellow = 0xEEEE9EFF
DarkGreen = 0x448844FF
PaleGreen = 0xAAFFAAFF
MedGreen = 0x88CC88FF
DarkBlue = 0x000055FF
PaleBlueGreen = 0xAAFFFFFF
PaleBlue = 0x0000BBFF
BlueGreen = 0x008888FF
GreyGreen = 0x55AAAAFF
PaleGreyGreen = 0x9EEEEEFF
YellowGreen = 0x99994CFF
MedBlue = 0x000099FF
GreyBlue = 0x005DBBFF
PaleGreyBlue = 0x4993DDFF
PurpleBlue = 0x8888CCFF

--Variable
resolution = srGetWindowSize()
res_x = resolution[0];
res_y = resolution[1];
stash_x = 10;
stash_y = 10;

function doit()
  askForWindow(askText);
  --windowManager("Board Setup", wmText);
  askForFocus();
  setupFlax();
  planeBoards();
end


function setupFlax()
  local was_shifted = lsShiftHeld();
  local is_done = false;
  local mx = 0;
  local my = 0;
  local z = 0;
  while not is_done do
    mx, my = srMousePos();

    if lsAltHeld() then
      --StashThis[0] ve 1 = {mx, my};
	  mx_old = mx
	  my_old = my
	  srReadScreen();
	  stash = srFindImageInRange("ThisIs.png", mx, my - 250, 250, 250);
	  	if stash_x > 1000 then
			stash_y = stash_y + 135;
			stash_x = 0;
		else
			safeDrag(stash[0], stash[1], stash_x, stash_y);
			stash_x = stash_x + 200;
			srSetMousePos(mx_old, my_old);
		end
    end

    checkBreak();
	    
    local y = 10;
    lsPrint(5, y, z, 0.7, 0.7, 0xf0f0f0ff, "Set flax bed locations by pushing shift.")
	lsDisplaySystemSprite(1, 10, 30, 1, 30, 20, 0xFFFFFFff)
	lsDisplaySystemSprite(1, 11, 31, 2, 28, 18, 0x000000FF)
	lsPrint(20, 32, 3, 0.7, 0.7, 0xf0f0f0ff, "E")
   
	local is_shifted = lsShiftHeld();
    if is_shifted and not was_shifted then
      is_done = 1;
    end
    was_shifted = is_shifted;

    if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff,
                    "End script") then
      error "Clicked End Script button";
    end

    lsDoFrame();
    lsSleep(100);
  end
end


function planeBoards()
	local click_delay = 200;
  while 1 do
    -- Click pin ups to refresh the window
    clickAllImages("ThisIs.png");
    sleepWithStatus(500, "Refreshing");
	
	srReadScreen();
	local msg = "";
	local clickCount = 0;
	local ThisIsList = findAllImages("ThisIs.png");
	local i;
	for i=1,#ThisIsList do
		local x = ThisIsList[i][0];
		local y = ThisIsList[i][1];
		local width = 100;
		local height = 250;
		local util = srFindImageInRange("utility.png", x, y, width, height, 5000);
		if(util) then
			height = util[1] - y;
			local p = srFindImageInRange("makeBricks.png", x, y, width, height);
			local h = srFindImageInRange("Take.png", x, y, width, height);

			if(e) then
				srSetMousePos(e[0],e[1]);
				clickCount = clickCount + 1;
				srReadScreen();
			end
			if(p) then
				safeClick(p[0]+4,p[1]+4);
				clickCount = clickCount + 1;
				srReadScreen();
			end
			if(h) then
				srClickMouseNoMove(h[0]+4,h[1]+4);
				clickCount = clickCount + 1;
				sleepWithStatus(1000, "Taking");
				srReadScreen();
				e = srFindImageInRange("every.png", x, y, width, height);
				srClickMouseNoMove(e[0] + 5,e[1] + 5,1);
				
			end
			
		end
	end
	if(msg == "") then
		msg = "Clicked " .. clickCount .. " windows";
	end
    sleepWithStatus(pause_time, msg);
  end
  return quit_message;
end
